/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractCalendar;
import java.util.TimeZone;

/**
 *  @author amarkhel
 

 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UICalendar extends AbstractCalendar
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.Calendar";

    public static final String COMPONENT_FAMILY="org.richfaces.Calendar";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UICalendar() {
        super();
        setRendererType("org.richfaces.CalendarRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "inputblur",
        "inputchange",
        "inputkeyup",
        "inputclick",
        "inputmouseover",
        "inputmousemove",
        "inputselect",
        "inputkeydown",
        "inputfocus",
        "inputkeypress",
        "inputmouseout",
        "inputmouseup",
        "inputmousedown",
        "inputdblclick"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        boundaryDatesMode,
        buttonClass,
        buttonIcon,
        buttonIconDisabled,
        buttonLabel,
        currentDate,
        datePattern,
        dayEnabled,
        dayStyleClass,
        defaultTime,
        direction,
        disabled,
        enableManualInput,
        firstWeekDay,
        hidePopupOnScroll,
        horizontalOffset,
        inputClass,
        inputSize,
        inputStyle,
        jointPoint,
        minDaysInFirstWeek,
        monthLabels,
        monthLabelsShort,
        oninputblur,
        oninputchange,
        oninputclick,
        oninputdblclick,
        oninputfocus,
        oninputkeydown,
        oninputkeypress,
        oninputkeyup,
        oninputmousedown,
        oninputmousemove,
        oninputmouseout,
        oninputmouseover,
        oninputmouseup,
        oninputselect,
        popup,
        resetTimeOnDateSelect,
        showApplyButton,
        showFooter,
        showHeader,
        showInput,
        showWeekDaysBar,
        showWeeksBar,
        style,
        tabindex,
        timeZone,
        todayControlMode,
        verticalOffset,
        weekDayLabels,
        weekDayLabelsShort,
        zindex

    }


 
    public String getBoundaryDatesMode() {
        return (String) getStateHelper().eval(Properties.boundaryDatesMode, "inactive");
    }
    
    public void setBoundaryDatesMode(String boundaryDatesMode) {
        getStateHelper().put(Properties.boundaryDatesMode, boundaryDatesMode);
    }

 
    public String getButtonClass() {
        return (String) getStateHelper().eval(Properties.buttonClass);
    }
    
    public void setButtonClass(String buttonClass) {
        getStateHelper().put(Properties.buttonClass, buttonClass);
    }

 
    public String getButtonIcon() {
        return (String) getStateHelper().eval(Properties.buttonIcon);
    }
    
    public void setButtonIcon(String buttonIcon) {
        getStateHelper().put(Properties.buttonIcon, buttonIcon);
    }

 
    public String getButtonIconDisabled() {
        return (String) getStateHelper().eval(Properties.buttonIconDisabled);
    }
    
    public void setButtonIconDisabled(String buttonIconDisabled) {
        getStateHelper().put(Properties.buttonIconDisabled, buttonIconDisabled);
    }

 
    public String getButtonLabel() {
        return (String) getStateHelper().eval(Properties.buttonLabel);
    }
    
    public void setButtonLabel(String buttonLabel) {
        getStateHelper().put(Properties.buttonLabel, buttonLabel);
    }

 
    public Object getCurrentDate() {
        return (Object) getStateHelper().eval(Properties.currentDate);
    }
    
    public void setCurrentDate(Object currentDate) {
        getStateHelper().put(Properties.currentDate, currentDate);
    }

 
    public String getDatePattern() {
        return (String) getStateHelper().eval(Properties.datePattern, "MMM d, yyyy");
    }
    
    public void setDatePattern(String datePattern) {
        getStateHelper().put(Properties.datePattern, datePattern);
    }

 
    public boolean isDayEnabled() {
        return Boolean.valueOf(getStateHelper().eval(Properties.dayEnabled, false).toString());
    }
    
    public void setDayEnabled(boolean dayEnabled) {
        getStateHelper().put(Properties.dayEnabled, dayEnabled);
    }

 
    public String getDayStyleClass() {
        return (String) getStateHelper().eval(Properties.dayStyleClass);
    }
    
    public void setDayStyleClass(String dayStyleClass) {
        getStateHelper().put(Properties.dayStyleClass, dayStyleClass);
    }

 
    public Object getDefaultTime() {
        return (Object) getStateHelper().eval(Properties.defaultTime);
    }
    
    public void setDefaultTime(Object defaultTime) {
        getStateHelper().put(Properties.defaultTime, defaultTime);
    }

 
    public String getDirection() {
        return (String) getStateHelper().eval(Properties.direction, "AA");
    }
    
    public void setDirection(String direction) {
        getStateHelper().put(Properties.direction, direction);
    }

 
    public boolean isDisabled() {
        return Boolean.valueOf(getStateHelper().eval(Properties.disabled, false).toString());
    }
    
    public void setDisabled(boolean disabled) {
        getStateHelper().put(Properties.disabled, disabled);
    }

 
    public boolean isEnableManualInput() {
        return Boolean.valueOf(getStateHelper().eval(Properties.enableManualInput, false).toString());
    }
    
    public void setEnableManualInput(boolean enableManualInput) {
        getStateHelper().put(Properties.enableManualInput, enableManualInput);
    }

 
    public int getFirstWeekDay() {
        return (Integer) getStateHelper().eval(Properties.firstWeekDay, Integer.MIN_VALUE);
    }
    
    public void setFirstWeekDay(int firstWeekDay) {
        getStateHelper().put(Properties.firstWeekDay, firstWeekDay);
    }

 
    public String getHidePopupOnScroll() {
        return (String) getStateHelper().eval(Properties.hidePopupOnScroll, "true");
    }
    
    public void setHidePopupOnScroll(String hidePopupOnScroll) {
        getStateHelper().put(Properties.hidePopupOnScroll, hidePopupOnScroll);
    }

 
    public String getHorizontalOffset() {
        return (String) getStateHelper().eval(Properties.horizontalOffset, "0");
    }
    
    public void setHorizontalOffset(String horizontalOffset) {
        getStateHelper().put(Properties.horizontalOffset, horizontalOffset);
    }

 
    public String getInputClass() {
        return (String) getStateHelper().eval(Properties.inputClass);
    }
    
    public void setInputClass(String inputClass) {
        getStateHelper().put(Properties.inputClass, inputClass);
    }

 
    public String getInputSize() {
        return (String) getStateHelper().eval(Properties.inputSize);
    }
    
    public void setInputSize(String inputSize) {
        getStateHelper().put(Properties.inputSize, inputSize);
    }

 
    public String getInputStyle() {
        return (String) getStateHelper().eval(Properties.inputStyle);
    }
    
    public void setInputStyle(String inputStyle) {
        getStateHelper().put(Properties.inputStyle, inputStyle);
    }

 
    public String getJointPoint() {
        return (String) getStateHelper().eval(Properties.jointPoint, "AA");
    }
    
    public void setJointPoint(String jointPoint) {
        getStateHelper().put(Properties.jointPoint, jointPoint);
    }

 
    public int getMinDaysInFirstWeek() {
        return (Integer) getStateHelper().eval(Properties.minDaysInFirstWeek, Integer.MIN_VALUE);
    }
    
    public void setMinDaysInFirstWeek(int minDaysInFirstWeek) {
        getStateHelper().put(Properties.minDaysInFirstWeek, minDaysInFirstWeek);
    }

 
    public Object getMonthLabels() {
        return (Object) getStateHelper().eval(Properties.monthLabels);
    }
    
    public void setMonthLabels(Object monthLabels) {
        getStateHelper().put(Properties.monthLabels, monthLabels);
    }

 
    public Object getMonthLabelsShort() {
        return (Object) getStateHelper().eval(Properties.monthLabelsShort);
    }
    
    public void setMonthLabelsShort(Object monthLabelsShort) {
        getStateHelper().put(Properties.monthLabelsShort, monthLabelsShort);
    }

 
    public String getOninputblur() {
        return (String) getStateHelper().eval(Properties.oninputblur);
    }
    
    public void setOninputblur(String oninputblur) {
        getStateHelper().put(Properties.oninputblur, oninputblur);
    }

 
    public String getOninputchange() {
        return (String) getStateHelper().eval(Properties.oninputchange);
    }
    
    public void setOninputchange(String oninputchange) {
        getStateHelper().put(Properties.oninputchange, oninputchange);
    }

 
    public String getOninputclick() {
        return (String) getStateHelper().eval(Properties.oninputclick);
    }
    
    public void setOninputclick(String oninputclick) {
        getStateHelper().put(Properties.oninputclick, oninputclick);
    }

 
    public String getOninputdblclick() {
        return (String) getStateHelper().eval(Properties.oninputdblclick);
    }
    
    public void setOninputdblclick(String oninputdblclick) {
        getStateHelper().put(Properties.oninputdblclick, oninputdblclick);
    }

 
    public String getOninputfocus() {
        return (String) getStateHelper().eval(Properties.oninputfocus);
    }
    
    public void setOninputfocus(String oninputfocus) {
        getStateHelper().put(Properties.oninputfocus, oninputfocus);
    }

 
    public String getOninputkeydown() {
        return (String) getStateHelper().eval(Properties.oninputkeydown);
    }
    
    public void setOninputkeydown(String oninputkeydown) {
        getStateHelper().put(Properties.oninputkeydown, oninputkeydown);
    }

 
    public String getOninputkeypress() {
        return (String) getStateHelper().eval(Properties.oninputkeypress);
    }
    
    public void setOninputkeypress(String oninputkeypress) {
        getStateHelper().put(Properties.oninputkeypress, oninputkeypress);
    }

 
    public String getOninputkeyup() {
        return (String) getStateHelper().eval(Properties.oninputkeyup);
    }
    
    public void setOninputkeyup(String oninputkeyup) {
        getStateHelper().put(Properties.oninputkeyup, oninputkeyup);
    }

 
    public String getOninputmousedown() {
        return (String) getStateHelper().eval(Properties.oninputmousedown);
    }
    
    public void setOninputmousedown(String oninputmousedown) {
        getStateHelper().put(Properties.oninputmousedown, oninputmousedown);
    }

 
    public String getOninputmousemove() {
        return (String) getStateHelper().eval(Properties.oninputmousemove);
    }
    
    public void setOninputmousemove(String oninputmousemove) {
        getStateHelper().put(Properties.oninputmousemove, oninputmousemove);
    }

 
    public String getOninputmouseout() {
        return (String) getStateHelper().eval(Properties.oninputmouseout);
    }
    
    public void setOninputmouseout(String oninputmouseout) {
        getStateHelper().put(Properties.oninputmouseout, oninputmouseout);
    }

 
    public String getOninputmouseover() {
        return (String) getStateHelper().eval(Properties.oninputmouseover);
    }
    
    public void setOninputmouseover(String oninputmouseover) {
        getStateHelper().put(Properties.oninputmouseover, oninputmouseover);
    }

 
    public String getOninputmouseup() {
        return (String) getStateHelper().eval(Properties.oninputmouseup);
    }
    
    public void setOninputmouseup(String oninputmouseup) {
        getStateHelper().put(Properties.oninputmouseup, oninputmouseup);
    }

 
    public String getOninputselect() {
        return (String) getStateHelper().eval(Properties.oninputselect);
    }
    
    public void setOninputselect(String oninputselect) {
        getStateHelper().put(Properties.oninputselect, oninputselect);
    }

 
    public boolean isPopup() {
        return Boolean.valueOf(getStateHelper().eval(Properties.popup, true).toString());
    }
    
    public void setPopup(boolean popup) {
        getStateHelper().put(Properties.popup, popup);
    }

 
    public boolean isResetTimeOnDateSelect() {
        return Boolean.valueOf(getStateHelper().eval(Properties.resetTimeOnDateSelect, false).toString());
    }
    
    public void setResetTimeOnDateSelect(boolean resetTimeOnDateSelect) {
        getStateHelper().put(Properties.resetTimeOnDateSelect, resetTimeOnDateSelect);
    }

 
    public boolean isShowApplyButton() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showApplyButton, false).toString());
    }
    
    public void setShowApplyButton(boolean showApplyButton) {
        getStateHelper().put(Properties.showApplyButton, showApplyButton);
    }

 
    public boolean isShowFooter() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showFooter, true).toString());
    }
    
    public void setShowFooter(boolean showFooter) {
        getStateHelper().put(Properties.showFooter, showFooter);
    }

 
    public boolean isShowHeader() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showHeader, true).toString());
    }
    
    public void setShowHeader(boolean showHeader) {
        getStateHelper().put(Properties.showHeader, showHeader);
    }

 
    public boolean isShowInput() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showInput, true).toString());
    }
    
    public void setShowInput(boolean showInput) {
        getStateHelper().put(Properties.showInput, showInput);
    }

 
    public boolean isShowWeekDaysBar() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showWeekDaysBar, true).toString());
    }
    
    public void setShowWeekDaysBar(boolean showWeekDaysBar) {
        getStateHelper().put(Properties.showWeekDaysBar, showWeekDaysBar);
    }

 
    public boolean isShowWeeksBar() {
        return Boolean.valueOf(getStateHelper().eval(Properties.showWeeksBar, true).toString());
    }
    
    public void setShowWeeksBar(boolean showWeeksBar) {
        getStateHelper().put(Properties.showWeeksBar, showWeeksBar);
    }

 
    public String getStyle() {
        return (String) getStateHelper().eval(Properties.style);
    }
    
    public void setStyle(String style) {
        getStateHelper().put(Properties.style, style);
    }

 
    public String getTabindex() {
        return (String) getStateHelper().eval(Properties.tabindex);
    }
    
    public void setTabindex(String tabindex) {
        getStateHelper().put(Properties.tabindex, tabindex);
    }

 
    public java.util.TimeZone getTimeZone() {
        return (TimeZone) getStateHelper().eval(Properties.timeZone, TimeZone.getDefault());
    }
    
    public void setTimeZone(java.util.TimeZone timeZone) {
        getStateHelper().put(Properties.timeZone, timeZone);
    }

 
    public String getTodayControlMode() {
        return (String) getStateHelper().eval(Properties.todayControlMode, "select");
    }
    
    public void setTodayControlMode(String todayControlMode) {
        getStateHelper().put(Properties.todayControlMode, todayControlMode);
    }

 
    public String getVerticalOffset() {
        return (String) getStateHelper().eval(Properties.verticalOffset, "0");
    }
    
    public void setVerticalOffset(String verticalOffset) {
        getStateHelper().put(Properties.verticalOffset, verticalOffset);
    }

 
    public Object getWeekDayLabels() {
        return (Object) getStateHelper().eval(Properties.weekDayLabels);
    }
    
    public void setWeekDayLabels(Object weekDayLabels) {
        getStateHelper().put(Properties.weekDayLabels, weekDayLabels);
    }

 
    public Object getWeekDayLabelsShort() {
        return (Object) getStateHelper().eval(Properties.weekDayLabelsShort);
    }
    
    public void setWeekDayLabelsShort(Object weekDayLabelsShort) {
        getStateHelper().put(Properties.weekDayLabelsShort, weekDayLabelsShort);
    }

 
    public int getZindex() {
        return (Integer) getStateHelper().eval(Properties.zindex, 3);
    }
    
    public void setZindex(int zindex) {
        getStateHelper().put(Properties.zindex, zindex);
    }

}